CAAT.Module( {
    defines : "FIAW.Actor.LoadingWindow",
    depends : [
        "CAAT.Foundation.ActorContainer"
    ],
    extendsClass : "CAAT.Foundation.ActorContainer",

    extendsWith : function() {

        return {

            bgContainer : null,
            textActor : null,

            text : null,
            fontType : "sixcap-white",
            bgColor : "#000",

            scene : null,

            __init: function(scene){
                this.__super();
                this.scene = scene;
                this.setSize(this.scene.width, this.scene.height).enableEvents(false);
                return this;
            },

            showWindow : function(text, bgColor, fontType){
                this.bgColor = bgColor || this.bgColor;
                this.fontType = fontType || this.fontType;
                this.text = text;
                this.enableEvents(true);

                this.bgContainer = new CAAT.Foundation.ActorContainer()
                    .setFillStyle(this.bgColor)
                    .setSize(this.scene.width, this.scene.height)
                    .enableEvents(true)
                    .setAlpha(0.9)
                    .setLocation(0,0);

                this.addChild(this.bgContainer);

                this.textActor = new CAAT.Foundation.UI.TextActor()
                    .setFont(FIAW.Utils.getFont(this.fontType))
                    .setText(this.text + " ")
                    .setTextAlign("center")
                    .setBaseline("middle")
                    .cacheAsBitmap()
                    .setScale(this.scene.gameScale, this.scene.gameScale)
                    .setLocation(this.width/2, this.height/2)
                    .enableEvents(false);

                this.addChild(this.textActor);

            },

            hideWindow : function(){
                this.enableEvents(false);
                this.bgContainer.setDiscardable(true).setExpired(true);
                this.textActor.setDiscardable(true).setExpired(true);
            }

        };

    }

});