
CAAT.Module( {
    defines : "FIAW.Actor.TimeClock",
    depends : [
        "CAAT.Foundation.ActorContainer"
    ],
    extendsClass : "CAAT.Foundation.ActorContainer",

    extendsWith : function() {

        return {

            director: null,
            time: FIAW.Globals.G_TURN_TIME,
            degrees: 0,
            calc: {
                w: [0, 0, 0, 0],
                h: [0, 0, 0, 0]
            },
            el: null,
            ww: null, hh: null,
            pauseIcon: null,

            __init: function(director){
                this.__super();
                this.director = director;

                this.setGlobalAnchor(0.5, 0.5)
                    .enableEvents(true)
                    .setBackgroundImage(this.director.getImage('barra-tiempo'));

                this.el = this.backgroundImage.mapInfo[this.backgroundImage.spriteIndex];
                this.ww = this.el.width/this.director.getValueForKey('IMS');
                this.hh = this.el.height/this.director.getValueForKey('IMS');

                //this.setBounds(this.x - this.ww/2, this.y - this.hh/2, this.x + this.ww/2, this.y + this.hh/2);
                this.setSize(this.ww, this.hh);

                this.calculateTimeBar();

                this.pauseIcon = new CAAT.Foundation.Actor()
                    .setBackgroundImage(this.director.getImage('pause'))
                    .setGlobalAnchor(0.5, 0.5)
                    .rescale()
                    .enableEvents(false)
                    .setLocation(this.ww/2, this.hh/2);

                this.addChild(this.pauseIcon);

                return this;
            },

            setTime: function(time) {
                this.time = time/1000;
                this.degrees = 360 - (360*this.time)/FIAW.Globals.G_TURN_TIME;
                this.calculateTimeBar();
                return this;
            },

            calculateTimeBar: function(){

                var ww = this.ww;
                var hh = this.hh;

                if(this.degrees == 360) this.degrees = 0;

                if(this.degrees < 90){

                    if(this.degrees <= 45){
                        this.calc.h[0] = 0;
                        this.calc.w[0] = ww/2 + this.getCalc(ww/2);
                    }else{
                        this.calc.w[0] = ww;
                        this.calc.h[0] = this.getCalc(hh/2);
                    }

                }

                if(this.degrees < 180){

                    if(this.degrees <= 90){
                        this.calc.h[1] = hh/2;
                        this.calc.w[1] = ww;
                    }else if(this.degrees <= 135){
                        this.calc.h[1] = hh/2 + this.getCalc(hh/2);
                        this.calc.w[1] = ww;
                    }else{
                        this.calc.h[1] = hh;
                        this.calc.w[1] = ww - this.getCalc(ww/2);
                    }
                }
                
                if(this.degrees < 270){

                    if(this.degrees <= 180){
                        this.calc.h[2] = hh;
                        this.calc.w[2] = ww/2;
                    }else if(this.degrees <= 225){
                        this.calc.h[2] = hh;
                        this.calc.w[2] = ww/2 - this.getCalc(ww/2);
                    }else{
                        this.calc.h[2] = hh - this.getCalc(hh/2);
                        this.calc.w[2] = 0;
                    }

                }

                if(this.degrees < 359){

                    if(this.degrees <= 270){
                        this.calc.h[3] = hh/2;
                        this.calc.w[3] = 0;
                    }else if(this.degrees <= 315){
                        this.calc.h[3] = hh/2 - this.getCalc(hh/2);
                        this.calc.w[3] = 0;
                    }else{
                        this.calc.h[3] = 0;
                        this.calc.w[3] = this.getCalc(ww/2);
                    }
                }

            },

            paint: function(director, time){
                var ctx = director.ctx;
                var ww = this.ww;
                var hh = this.hh;

                ctx.save();
        
                ctx.beginPath();

                if(this.degrees <= 90){

                    ctx.moveTo(ww/2, hh/2);
                    ctx.lineTo(this.calc.w[0], this.calc.h[0]);
                    ctx.lineTo(ww, 0);
                    ctx.lineTo(ww, hh/2);

                }
                
                if(this.degrees <= 180){

                    ctx.moveTo(ww/2, hh/2);
                    ctx.lineTo(this.calc.w[1], this.calc.h[1]);
                    ctx.lineTo(ww, hh);
                    ctx.lineTo(ww/2, hh);
                }
                
                if(this.degrees <= 270){

                    ctx.moveTo(ww/2, hh/2);
                    ctx.lineTo(this.calc.w[2], this.calc.h[2]);
                    ctx.lineTo(0, hh);
                    ctx.lineTo(0, hh/2);
                }

                if(this.degrees <= 359){

                    ctx.moveTo(ww/2, hh/2);
                    ctx.lineTo(this.calc.w[3], this.calc.h[3]);
                    ctx.lineTo(0, 0);
                    ctx.lineTo(ww/2, 0);
                }
            
                ctx.closePath();
                ctx.clip();

                ctx.drawImage(
                    this.backgroundImage.image,
                    this.el.x, this.el.y,
                    this.el.width, this.el.height,
                    (this.backgroundImage.offsetX + 0) >> 0, (this.backgroundImage.offsetY + 0) >> 0,
                    this.ww, this.hh);

                ctx.restore();

                return this;
            },

            getCalc: function(wh){
                return (wh*(this.degrees%45))/45;
            }

        };


    }


});