
CAAT.Module( {
    defines : "FIAW.Game.Utils",
    depends: [
        "FIAW.Manager.RateManager",
        "FIAW.Manager.InAppsManager",
        "FIAW.Manager.AdsManager"
    ],

    extendsWith : function() {

        return {

            fonts: {},
            rate: null,
            adsManager: null,
            inAppsManager: null,

            __init: function(){
                console.log('Utils ON');
                this.rate = new FIAW.Manager.RateManager();
                this.adsManager = new FIAW.Manager.AdsManager(CAAT.currentDirector);
                return this;
            },

            initInAppsManager: function(gamePlayManager){
                this.inAppsManager = new FIAW.Manager.InAppsManager(gamePlayManager);
                return this;
            },

            createFont: function(director, name, image, fnt){

                var self = this;

                function cb(fnt, text)
                {
                    if(fnt == "ok") {
                        self.fonts[name] = new CAAT.Foundation.SpriteImage( image )
                            .initializeFromGlyphDesigner( text.split("\n") , 1);
                    }else{
                        console.log("Error loading font.");
                    }
                }

                new CAAT.Module.Preloader.XHR().load(cb, fnt, false);
            },

            getFont: function(name){
                return this.fonts[name];
            },

            maxIndex: function(arr){
                var i, n = 0;
                for(i in arr){
                    if(arr[i] >= n) n = arr[i];
                }

                return arr.indexOf(n);
            },

            getCorrectName: function(name){
                var r;
                if(name.length > 13){
                    r = name.substr(0,11) + "...";
                }else{
                    r = name;
                }

                return r;
            },

            isAndroidOrIos: function(){

                return (/ios/.test(navigator.userAgent) || /android/.test(navigator.userAgent));

            },

            isAmazonApp: function(){
                var r = false;
                if(this.isAndroidOrIos()){
                    if(CocoonJS.Store.getStoreType() == CocoonJS.Store.StoreType.AMAZON_STORE) r = true;
                }

                return r;
            }

        };

    }

});