
CAAT.Module( {
    defines : "FIAW.Manager.AdsManager",

    extendsWith : function() {

        return {

            director: null,
            banner: {
                ready: false,
                visible : false
            },
            fullScreen: {
                ready: false,
                visible : false
            },

            gameOverActor: null,

            __init: function(director){
                this.director = director;
                this.initBanner();
                this.initFullScreen();
                CocoonJS.Ad.preloadBanner();
                CocoonJS.Ad.preloadFullScreen();

                return this;
            },

            initBanner: function(){
                var self = this;
                console.log('Loading Banner...');
                
                CocoonJS.Ad.onBannerShown.addEventListener(function(){
                    console.log('Banner onBannerShow');
                });
                CocoonJS.Ad.onBannerHidden.addEventListener(function(){
                    console.log('Banner onBannerHidden');
                });

                CocoonJS.Ad.onBannerReady.addEventListener(function(width, height){
                    if(FIAW.adsEnabled){
                        console.log('Banner onBannerReady (' + width + ', ' + height + ')');

                        CocoonJS.Ad.setBannerLayout(CocoonJS.Ad.BannerLayout.BOTTOM_CENTER);
                        CocoonJS.Ad.showBanner();

                        self.banner.ready = true;
                    }
                });
            },

            initFullScreen: function(){
                var self = this;
                console.log('Loading FullScreenAds...');

                CocoonJS.Ad.onFullScreenShown.addEventListener(function(){
                    console.log('FullScreen onFullScreenShow');
                    if(FIAW.musicEnabled){
                        self.director.musicStop();
                    }
                    CAAT.endLoop();
                });
                CocoonJS.Ad.onFullScreenHidden.addEventListener(function(){
                    console.log('FullScreen onFullScreenHidden');
                    CAAT.loop(60);
                    self.fullScreen.visible = false;
                    if(self.gameOverActor) self.gameOverActor.stopAdsTimer(); //Si existe botón de tiempo lo elimino
                    if(FIAW.musicEnabled){
                        self.director.musicPlay('music');
                    }
                });
                CocoonJS.Ad.onFullScreenReady.addEventListener(function(){
                    console.log('FullScreen onFullScreenReady');
                    self.fullScreen.ready = true;
                });
            },

            showBanner: function(){

                if(FIAW.adsEnabled){
                    CocoonJS.Ad.setBannerLayout(CocoonJS.Ad.BannerLayout.BOTTOM_CENTER);
                    CocoonJS.Ad.showBanner();
                }
            },

            hideBanner: function(){
                this.banner.visible = false;
                CocoonJS.Ad.hideBanner();
            },

            showFullScreen: function(gameOverActor){
                this.gameOverActor = gameOverActor;

                if(FIAW.adsEnabled){
                    this.fullScreen.visible = true;
                    CocoonJS.Ad.showFullScreen();
                }
            }


        };

    }

});