
CAAT.Module( {
    defines : "FIAW.Manager.RateManager",

    extendsWith : function() {

        return {

            __playedGames: 0,

            rateGame:function(){

                var STORE_TYPE = CocoonJS.Store.getStoreType();
                var rateURL;

                switch (STORE_TYPE){
                    case CocoonJS.Store.StoreType.APP_STORE:
                        rateURL = "http://redirect.ludei.com/2012";
                        break;
                    case CocoonJS.Store.StoreType.PLAY_STORE:
                        rateURL = "http://redirect.ludei.com/2011";
                        break;
                    case CocoonJS.Store.StoreType.AMAZON_STORE:
                        rateURL = "http://redirect.ludei.com/2013";
                        break;
                    case CocoonJS.Store.StoreType.MOCK_STORE:
                        if (/ios/.test(navigator.userAgent)) {
                            rateURL = "http://redirect.ludei.com/2012";
                        }
                        else if (/android/.test(navigator.userAgent))
                        {
                            rateURL = "http://redirect.ludei.com/2011";
                        }
                    break;
                }

                CAAT.Module.Storage.LocalStorage.save("FIAW.RatedVersion",FIAW.Globals.G_VERSION);
                CocoonJS.App.openURL(rateURL);
            },

            setPlayedGames: function(num){

                this.__playedGames = num;
            },

            getPlayedGames: function(){
                return this.__playedGames;
            },

            tryRate: function(){

                var self = this;

                var numTimesInGame = CAAT.Module.Storage.LocalStorage.load("FIAW.numTimesInGame",0);
                numTimesInGame ++;

                CAAT.Module.Storage.LocalStorage.save("FIAW.numTimesInGame",numTimesInGame);

                CocoonJS.App.onMessageBoxConfirmed.addEventListenerOnce( function() {
                    self.rateGame();
                });

                CocoonJS.App.onMessageBoxDenied.addEventListenerOnce( function() {
                    numTimesInGame = 0;
                    CAAT.Module.Storage.LocalStorage.save("FIAW.numTimesInGame",numTimesInGame);
                    self.setPlayedGames(0);
                });

                var ratedVersion = CAAT.Module.Storage.LocalStorage.load("FIAW.RatedVersion",-1);
                if(ratedVersion == FIAW.Globals.G_VERSION){

                    CAAT.Module.Storage.LocalStorage.save("FIAW.numTimesInGame",0);

                }

                if ( ratedVersion!=FIAW.Globals.G_VERSION  && (numTimesInGame>=FIAW.Globals.G_MIN_TIME_MENU || this.getPlayedGames() >= FIAW.Globals.G_MIN_TIME_PLAY)){
                    this.showRateMessage();
                }
            },

            rateMenu: function(){
                if(this.menuCanShowRate()){

                    this.rateGame();

                }
            },

            menuCanShowRate: function(){
                var ratedVersion = CAAT.Module.Storage.LocalStorage.load("FIAW.RatedVersion",-1);
                if(FIAW.Utils.isAndroidOrIos() && ratedVersion != FIAW.Globals.G_VERSION){

                    return true;

                }

                return false;
            },

            showRateMessage:function(){

                var rateTitle = FIAW.localeText.getString("T_RATE_TITLE","Do you like Four In A Row?",null);
                var rateBody = FIAW.localeText.getString("T_RATE_BODY","Rate it and help us to improve the game.",null);
                var rateOkButton = FIAW.localeText.getString("T_RATE_OK_BUTTON","Ok!",null);
                var rateKoButton = FIAW.localeText.getString("T_RATE_KO_BUTTON","Remind me later",null);

                CocoonJS.App.showMessageBox(
                    rateTitle,
                    rateBody,
                    rateOkButton,
                    rateKoButton);
            }

        };


    }


});